<?php

require_once dirname(__FILE__)."/sign-valid.php";

$mode = abs(intval($_GET["mode"]));
$act  = abs(intval($_GET["action"]));
$uid  = abs(intval($_GET["uid"]));
$err  = abs(intval($_GET["error"]));

// Admin file/interface
$admin = "./admin.php";

$query =& $db->query("SELECT * FROM settings WHERE opt LIKE 'version'");

if (PEAR::isError($req)) {
	echo "Error:".$req->getMessage();
}

$query->fetchInto($antv, DB_FETCHMODE_ASSOC);
$antversion = $antv["optvalue"];

switch ($err) {
    case '1':
            $error = "Ошибка ввода пароля: старый пароль неверен!";
            break;
    case '2':
            $error = "Ошибка ввода пароля: новые пароли не совпадают!";
            break;
}

switch ($mode) {
    case '0':
	    $display = "<ul><li><a href='".$admin."?mode=1'>Управление дистрибутивами</a></li><li><a href='".$admin."?mode=2'>Управление версиями дистрибутивов</a></li><li><a href='".$admin."?mode=3'>Управление репозиториями</a></li><li><a href='".$admin."?mode=4'>Управление секциями репозиториев</a></li><li><a href='".$admin."?mode=5'>Управление схемами репозиториев</a></li><li><a href='".$admin."?mode=7'>Управление типами репозиториев</a></li><li><a href='".$admin."?mode=8'>Управление корневыми папками репозиториев</a></li><li><a href='".$admin."?mode=6'>Управление настройками Ant</a></li><li><a href='./signout.php' style='color:red;'>Выход</a></li></ul>";
	    break;
    case '1':
	    // Работа с дистрибутивами
	    switch ($act) {
		case '0':
			// Список дистрибутивов
			$dist =& $db->query("SELECT * FROM distribution");
			if ($dist->numRows()>0) {
				$display = "В наличии есть:<ul id='distlist'>";
				while ($dist->fetchInto($info, DB_FETCHMODE_ASSOC)) {
				    $display .= "<li>".stripslashes($info["distname"])." &mdash; [<a href='".$admin."?mode=1&action=2&uid=".$info["dist_id"]."' class='edit'>править</a>][<a href='".$admin."?mode=1&action=3&uid=".$info["dist_id"]."' class='delete'>удалить</a>]</li>";
				}
				$display .= "</ul><p><a href='".$admin."?mode=1&action=1'>Добавить новый apt-дистрибутив</a></p>";
			}
			break;
		case '1':
			// Добавление нового дистрибутива
			$dtype =& $db->query("SELECT * FROM dtype");
			$type = "<select name='distType'>";
			while ($dtype->fetchInto($dtinfo, DB_FETCHMODE_ASSOC)) {
			    $type .= "<option value='".$dtinfo["type_id"]."'>".stripslashes($dtinfo["type"])."</option>";
			}
			$type .= "</select>\n";
			$display  = "<h3>Добавление нового apt-дистрибутива</h3>";
			$display .= "<form action='./process.php' method='POST' enctype='multipart/form-data'>\n";
			$display .= "<input type='hidden' name='mode' value='1'>\n";
			$display .= "Название дистрибутива: <input type='text' name='distName'><br>\n";
			$display .= "Представление в строке User-Agent'а: <input type='text' name='distUA'><br>\n";
			$display .= "Тип дистрибутива: ".$type."<br>";
			$display .= "Логотип дистрибутива (Прозрачный PNG): <input type='file' name='distLOGO'><br>";
			$display .= "<input type='submit' value='Создать'></form>\n";
			break;
		case '2':
			// Правка существующего дистрибутива
			$dist =& $db->query("SELECT * FROM distribution WHERE dist_id='$uid'");
			$dist->fetchInto($info, DB_FETCHMODE_ASSOC);
			$dtype =& $db->query("SELECT * FROM dtype");
			$type = "<select name='distType'>";
			while ($dtype->fetchInto($dtinfo, DB_FETCHMODE_ASSOC)) {
			    if ($info["disttype"]==$dtinfo["type_id"]) {
				$type .= "<option value='".$dtinfo["type_id"]."' selected>".stripslashes($dtinfo["type"])."</option>";
			    } else {
				$type .= "<option value='".$dtinfo["type_id"]."'>".stripslashes($dtinfo["type"])."</option>";			    
			    }
			}
			$type .= "</select>\n";
			$display  = "<h3>Правка apt-дистрибутива <em class='".stripslashes($info["distua"])."-em'>".stripslashes($info["distname"])."</em></h3>";
			$display .= "<form action='./process.php' method='POST' enctype='multipart/form-data'>\n";
			$display .= "<input type='hidden' name='mode' value='2'>\n";
			$display .= "<input type='hidden' name='distID' value='$uid'>\n";			
			$display .= "Название дистрибутива: <input type='text' name='distName' value='".stripslashes($info["distname"])."'><br>\n";
			$display .= "Представление в строке User-Agent'a: <input type='text' name='distUA' value='".stripslashes($info["distua"])."'><br>\n";
			$display .= "Тип дистрибутива: ".$type."<br>";
			$display .= "Логотип дистрибутива (Прозрачный PNG): <input type='file' name='distLOGO'><br>";
			$display .= "<input type='submit' value='Править'></form>\n";
			break;
		case '3':
			// Удаление существующего дистрибутива
			$dist =& $db->query("SELECT * FROM distribution WHERE dist_id='$uid'");
			$dist->fetchInto($info, DB_FETCHMODE_ASSOC);
			$display  = "<h3>Удаление apt-дистрибутива <em class='".stripslashes($info["distua"])."-em'>".stripslashes($info["distname"])."</em></h3>";			
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='3'>\n";
			$display .= "<input type='hidden' name='distID' value='$uid'>\n";			
			$display .= "<input type='hidden' name='distUA' value='".stripslashes($info["distua"])."'>\n";
			$display .= "<input type='submit' value='Удалить'></form>\n";
			break;
	    }
	    break;
	case '2':
	    // Работа с версиями дистрибутивов
	    switch ($act) {
		case '0':
			// Все версии имеющихся дистрибутивов
			$dist =& $db->query("SELECT * FROM distribution d JOIN version v ON d.dist_id=v.dist_id ORDER BY d.dist_id,v.version ASC");
			$display  = "В наличии есть следующие версии apt-дистрибутивов:<ul id='distlist'>";
			while ($dist->fetchInto($info, DB_FETCHMODE_ASSOC)) {
			    $display .= "<li>".stripslashes($info["distname"])." ".stripslashes($info["version"])." &#8220;".stripslashes($info["vname"])."&#8221; &mdash; [<a href='".$admin."?mode=2&action=2&uid=".$info["version_id"]."' class='edit'>править</a>][<a href='".$admin."?mode=2&action=3&uid=".$info["version_id"]."' class='delete'>удалить</a>]</li>";
			}
			$display .= "</ul><p><a href='".$admin."?mode=2&action=1'>Добавить новую версию дистрибутива</a></p>";
			break;
		case '1':
			// Добавление новой версии дистрибутива
			$dtype =& $db->query("SELECT * FROM distribution");
			$type = "<select name='distName'>";
			while ($dtype->fetchInto($dtinfo, DB_FETCHMODE_ASSOC)) {
			    $type .= "<option value='".$dtinfo["dist_id"]."'>".stripslashes($dtinfo["distname"])."</option>";
			}
			$type .= "</select>\n";
			$display  = "<h3>Добавление новой версии apt-дистрибутива</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='4'>\n";
			$display .= "Номер версии: <input type='text' name='versNum'><br>\n";
			$display .= "Название версии: <input type='text' name='versNam'><br>\n";			
			$display .= "Кодовое имя версии: <input type='text' name='versCN'><br>\n";
			$display .= "Дистрибутив: ".$type."<br>";
			$display .= "<input type='submit' value='Создать'></form>\n";
			break;
		case '2':
			// Правка имеющейся версии дистрибутива
			$vers =& $db->query("SELECT * FROM version v JOIN distribution d ON d.dist_id=v.dist_id WHERE version_id='$uid'");
			$vers->fetchInto($info, DB_FETCHMODE_ASSOC); 
			$display  = "<h3>Правка имеющейся версии <em>".stripslashes($info["distname"])."</em></h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='5'>\n";
			$display .= "<input type='hidden' name='versID' value='$uid'>\n";			
			$display .= "Номер версии: <input type='text' name='versNum' value='".stripslashes($info["version"])."'><br>\n";
			$display .= "Название версии: <input type='text' name='versNam' value='".stripslashes($info["vname"])."'><br>\n";			
			$display .= "Кодовое имя версии: <input type='text' name='versCN' value='".stripslashes($info["vcodename"])."'><br>\n";
			$display .= "<input type='submit' value='Править'></form>\n";
			break;
		case '3':
			// Удаление существующей версии дистрибутива
			$dist =& $db->query("SELECT * FROM version v JOIN distribution d ON v.dist_id=d.dist_id WHERE v.version_id='$uid'");
			$dist->fetchInto($info, DB_FETCHMODE_ASSOC);
			$display  = "<h3>Удаление версии ".stripslashes($info["version"])." (&#8220;".stripslashes($info["vname"])."&#8221;) <em>".stripslashes($info["distname"])."</em></h3>";			
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='6'>\n";
			$display .= "<input type='hidden' name='versID' value='$uid'>\n";			
			$display .= "<input type='submit' value='Удалить'></form>\n";
			break;
	    }
	    break;
        case '3':
            // Работа с репозиториями
            switch ($act) {
                case '0':
                        // Выбор дистрибутива
                        $dist =& $db->query("SELECT * FROM distribution d JOIN version v ON v.dist_id=d.dist_id ORDER BY d.dist_id,v.version_id ASC");
			$display  = "В наличии есть следующие версии apt-дистрибутивов:<ul id='distlist'>";
			while ($dist->fetchInto($info, DB_FETCHMODE_ASSOC)) {
			    $display .= "<li><a href='".$admin."?mode=3&action=1&uid=".$info["version_id"]."'>".stripslashes($info["distname"])." ".stripslashes($info["version"])." &#8220;".stripslashes($info["vname"])."&#8221;</a></li>";
			}
			$display .= "</ul>";
                        break;
                case '1':
                        // Список доступных репозиториев для конкретной версии дистрибутива
                        $reps =& $db->query("SELECT * FROM repository r JOIN ver2rep a ON a.rep_id=r.rep_id WHERE a.ver_id='$uid'");
                        $display = "Доступные репозитории для выбранного дистрибутива: <ul id='replist'>";
                        if ($reps->numRows()>0) {
                            while ($reps->fetchInto($info, DB_FETCHMODE_ASSOC)) {
                                $display .= "<li>[<a href='".$admin."?mode=3&action=3&uid=".$info["rep_id"]."' class='edit'>править</a>][<a href='".$admin."?mode=3&action=4&uid=".$info["rep_id"]."' class='delete'>удалить</a>] ".stripslashes($info["repname"])." &mdash; ".stripslashes($info["repdescribe"])."</li>";
                            }
                        }
                        $display .= "</ul><p><a href='".$admin."?mode=3&action=2&uid=".$uid."'>Добавить новый репозиторий</a></p>";
                        break;
                case '2':
                        // Новый репозиторий
                        $rep =& $db->query("SELECT * FROM distribution d JOIN version v ON v.dist_id=d.dist_id WHERE v.version_id='$uid'");
                        $rep->fetchInto($dist, DB_FETCHMODE_ASSOC);
                        $dist_id = $dist["dist_id"];
                        $dist_vname = stripslashes($dist["distname"])." ".stripslashes($dist["version"])." &#8220;".stripslashes($dist["vname"])."&#8221;";
			$dtype =& $db->query("SELECT * FROM scheme");
			$rscheme = "<select name='scheme'>";
			while ($dtype->fetchInto($dtinfo, DB_FETCHMODE_ASSOC)) {
			    $rscheme .= "<option value='".$dtinfo["scheme_id"]."'>".stripslashes($dtinfo["scheme"])."</option>";
			}
			$rscheme .= "</select>";
			$rtype =& $db->query("SELECT * FROM rtype");
			$reptype = "<select name='rtype'>";
			while ($rtype->fetchInto($rtinfo, DB_FETCHMODE_ASSOC)) {
			    $reptype .= "<option value='".$rtinfo["rtype_id"]."'>".stripslashes($rtinfo["rtype"])."</option>";
			}
			$reptype .= "</select>\n";
                        $sect =& $db->query("SELECT * FROM section s JOIN sect2dist d ON d.sect_id=s.sect_id WHERE d.dist_id='$dist_id'");
                        $list = "";
                        while ($sect->fetchInto($slist, DB_FETCHMODE_ASSOC)) {
                            $list .= "<input type='checkbox' name='sect[]' value='".$slist["sect_id"]."'> <span title='".stripslashes($slist["sectinfo"])."'>".stripslashes($slist["sectname"])."</span> ";
                        }
			$type .= "</select>\n";
			$rootfolder = "<select name='rootFolder'>\n";
			$root =& $db->query("SELECT * FROM root");
			while ($root->fetchInto($rfi, DB_FETCHMODE_ASSOC)) {
				$rootfolder .= "<option value='".$rfi["root_id"]."'>".stripslashes($rfi["root_folder"])."</option>";
			}
			$rootfolder .= "</select>";
			$display  = "<h3>Добавление нового репозитория для ".$dist_vname."</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='7'>\n";
			$display .= "<input type='hidden' name='vers' value='$uid'>\n";
			$display .= "Название репозитория (codename): <input type='text' name='repName'><br>\n";
			$display .= "Описание репозитория:<br> <textarea name='repInfo'></textarea><br>\n";
                        $display .= "Схема репозитория: ".$rscheme."<br>";
			$display .= "Тип репозитория: ".$reptype."<br>";
			$display .= "Корневая папка репозитория: ".$rootfolder."<br>";
                        $display .= "Секции: ".$list;
			$display .= "<br><input type='submit' value='Создать'></form>\n";			
                        break;
                case '3':
            		// Редактирование репозитория
			$rep =& $db->query("SELECT * FROM repository r JOIN ver2rep l ON l.rep_id=r.rep_id JOIN version v ON v.version_id=l.ver_id JOIN distribution d ON v.dist_id=d.dist_id JOIN root r2 ON r2.root_id=r.root_id WHERE r.rep_id='$uid'");
            		$rep->fetchInto($info, DB_FETCHMODE_ASSOC);
			$dist_vname = stripslashes($info["distname"])." ".stripslashes($info["version"])." &#8220;".stripslashes($info["vname"])."&#8221;";
            		$tlist = "<select name='scheme'>";
            		$sq =& $db->query("SELECT * FROM scheme");
            		while ($sq->fetchInto($type, DB_FETCHMODE_ASSOC)) {
            		    if ($type["scheme_id"]==$info["scheme_id"]) {
            			$tlist .= "<option value='".$type["scheme_id"]."' selected>".stripslashes($type["scheme"])."</option>";
            		    } else {
            			$tlist .= "<option value='".$type["scheme_id"]."'>".stripslashes($type["scheme"])."</option>";
            		    }
            		}
			$tlist .= "</select>";
			$tlist2 = "<select name='rtype'>";
			$sq =& $db->query("SELECT * FROM rtype");
            		while ($sq->fetchInto($type, DB_FETCHMODE_ASSOC)) {
            		    if ($type["rtype_id"]==$info["rtype_id"]) {
            			$tlist2 .= "<option value='".$type["rtype_id"]."' selected>".stripslashes($type["rtype"])."</option>";
            		    } else {
            			$tlist2 .= "<option value='".$type["rtype_id"]."'>".stripslashes($type["rtype"])."</option>";
            		    }
            		}
            		$tlist2 .= "</select>";
            		$list = "";
            		$req =& $db->query("SELECT * FROM section s JOIN sect2rep r ON s.sect_id=r.sect_id WHERE r.rep_id='$uid'");
            		if ($req->numRows()>0) {
            		    while ($req->fetchInto($sect, DB_FETCHMODE_ASSOC)) {
            			$list .= "<input type='checkbox' name='sect[]' value='".$sect["sect_id"]."' checked><span title='".stripslashes($sect["sectinfo"])."'>".stripslashes($sect["sectname"])."</span> ";
            		    }
            		}
            		$req =& $db->query("SELECT s.* FROM section s WHERE s.sect_id NOT IN (SELECT sect_id FROM sect2rep WHERE rep_id='$uid')");
            		if ($req->numRows()>0) {
            		    while ($req->fetchInto($sect, DB_FETCHMODE_ASSOC)) {
            			$list .= "<input type='checkbox' name='sect[]' value='".$sect["sect_id"]."'><span title='".stripslashes($sect["sectinfo"])."'>".stripslashes($sect["sectname"])."</span> ";
            		    }
            		}
			$rootfolder = "<select name='rootFolder'>\n";
			$req =& $db->query("SELECT * FROM root");
			if ($req->numRows()>0) {
				while ($req->fetchInto($rfi, DB_FETCHMODE_ASSOC)) {
					if ($rfi["root_id"]==$info["root_id"]) {
						$rootfolder .= "<option value='".$rfi["root_id"]."' selected>".stripslashes($rfi["root_folder"])."</option>";
					} else {
						$rootfolder .= "<option value='".$rfi["root_id"]."'>".stripslashes($rfi["root_folder"])."</option>";
					}
				}
			}
			$rootfolder .= "</select>";

			$display  = "<h3>Правка репозитория ".$info["repname"]." для <em>".$dist_vname."</em></h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='8'>\n";
			$display .= "<input type='hidden' name='rep' value='$uid'>\n";
			$display .= "Название репозитория (codename): <input type='text' name='repName' value='".stripslashes($info["repname"])."'><br>\n";
			$display .= "Описание репозитория:<br> <textarea name='repInfo'>".stripslashes($info["repdescribe"])."</textarea><br>\n";
                        $display .= "Схема репозитория: ".$tlist."<br>";
			$display .= "Тип репозитория: ".$tlist2."<br>";
			$display .= "Корневая папка репозитория: ".$rootfolder."<br>";
                        $display .= "Секции: ".$list;
			$display .= "<br><input type='submit' value='Править'></form>\n";			
            		break;
            	case '4':
            		// Удаление репозитория
			$rep =& $db->query("SELECT * FROM repository r JOIN ver2rep l ON l.rep_id=r.rep_id JOIN version v ON v.version_id=l.ver_id JOIN distribution d ON v.dist_id=d.dist_id WHERE r.rep_id='$uid'");
            		$rep->fetchInto($info, DB_FETCHMODE_ASSOC);
			$dist_vname = stripslashes($info["distname"])." ".stripslashes($info["version"])." &#8220;".stripslashes($info["vname"])."&#8221;";
			$display  = "<h3>Удаление репозитория ".$info["repname"]." для <em>".$dist_vname."</em></h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='9'>\n";
			$display .= "<input type='hidden' name='rep' value='$uid'>\n";
			$display .= "<input type='submit' value='Удалить'></form>\n";			
            		
            		break;
            }
            break;
        case '4':
            // Управление разделами
            switch ($act) {
        	case '0':
        		// Список секций
        		$req =& $db->query("SELECT * FROM section");
        		$display = "<p>Имеющиеся секции в репозиториях</p><ul class='sectlist'>";
        		while ($req->fetchInto($sect, DB_FETCHMODE_ASSOC)) {
        		    $sreq =& $db->query("SELECT * FROM distribution d JOIN sect2dist s ON s.dist_id=d.dist_id WHERE s.sect_id='".$sect["sect_id"]."'");
        		    $replist = "<small>Используется в ";
        		    while ($sreq->fetchInto($rep, DB_FETCHMODE_ASSOC)) {
        			$replist .= "<em>".stripslashes($rep["distname"])."</em>, ";
        		    }
        		    $replist = substr($replist, 0, -2);
        		    $replist .= "</small>";
        		    $display .= "<li><strong>".stripslashes($sect["sectname"])."</strong> &mdash; [<a href='".$admin."?mode=4&action=2&uid=".$sect["sect_id"]."' class='edit'>править</a>][<a href='".$admin."?mode=4&action=3&uid=".$sect["sect_id"]."' class='delete'>удалить</a>] &mdash; ".stripslashes($sect["sectinfo"])."<br>".$replist."</li>";
        		}
        		$display .= "</ul><p><a href='".$admin."?mode=4&action=1'>Добавить секцию</a></p>";
        		break;
        	case '1':
        		$req =& $db->query("SELECT * FROM distribution");
        		while ($req->fetchInto($dist, DB_FETCHMODE_ASSOC)) {
        		    $list .= "<br><input type='checkbox' name='dist' value='".$dist["dist_id"]."'>".stripslashes($dist["distname"])." ";
        		}
			$display  = "<h3>Создание секции репозитория</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='10'>\n";
			$display .= "Название секции (codename): <input type='text' name='sectName'><br>\n";
			$display .= "Описание секции:<br> <textarea name='sectInfo'></textarea><br>\n";
                        $display .= "Используется в дистрибутивах: ".$list;
			$display .= "<br><input type='submit' value='Добавить'></form>\n";			
        		break;
        	case '2':
        		$req =& $db->query("SELECT * FROM distribution d JOIN sect2dist s ON s.dist_id=d.dist_id WHERE s.sect_id='$uid'");
        		if ($req->numRows()>0) {
            		    while ($req->fetchInto($dist, DB_FETCHMODE_ASSOC)) {
        			$list .= "<br><input type='checkbox' name='dist[]' value='".$dist["dist_id"]."' checked>".stripslashes($dist["distname"])." ";
        		    }
        		}
        		$req =& $db->query("SELECT d.* FROM distribution d WHERE dist_id NOT IN (SELECT dist_id FROM sect2dist WHERE sect_id='$uid')");
        		if ($req->numRows()>0) {
        		    while ($req->fetchInto($dist, DB_FETCHMODE_ASSOC)) {
        			$list .= "<br><input type='checkbox' name='dist[]' value='".$dist["dist_id"]."'>".stripslashes($dist["distname"])." ";
        		    }
        		}
        		$req =& $db->query("SELECT * FROM section WHERE sect_id='$uid'");
        		$req->fetchInto($sect, DB_FETCHMODE_ASSOC);
			$display = "<h3>Правка секции репозитория</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='11'>\n";
			$display .= "<input type='hidden' name='sectID' value='$uid'>\n";			
			$display .= "Название секции (codename): <input type='text' name='sectName' value='".stripslashes($sect["sectname"])."'><br>\n";
			$display .= "Описание секции:<br> <textarea name='sectInfo'>".stripslashes($sect["sectinfo"])."</textarea><br>\n";
                        $display .= "Используется в дистрибутивах: ".$list;
			$display .= "<br><input type='submit' value='Править'></form>\n";			
        		break;
        	case '3':
        		$req =& $db->query("SELECT * FROM section WHERE sect_id='$uid'");
        		$req->fetchInto($sect, DB_FETCHMODE_ASSOC);
			$display = "<h3>Удаление секции <em>".stripslashes($sect["sectname"])."</em></h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='12'>\n";
			$display .= "<input type='hidden' name='sectID' value='$uid'>\n";			
			$display .= "<br><input type='submit' value='Удалить'></form>\n";			
        		break;
            }
            break;
	case '5':
	    // Управление схемами репозиториев
	    switch ($act) {
		case '0':
			// Список схем
			$req =& $db->query("SELECT * FROM scheme");
        		$display = "<p>Имеющиеся схемы репозиториев</p><ul class='sectlist'>";
        		while ($req->fetchInto($sect, DB_FETCHMODE_ASSOC)) {
        			$display .= "<li>".stripslashes($sect["scheme"])." &mdash; [<a href='".$admin."?mode=5&action=2&uid=".$sect["scheme_id"]."' class='edit'>править</a>][<a href='".$admin."?mode=5&action=3&uid=".$sect["scheme_id"]."' class='delete'>удалить</a>]</li>";
        		}
        		$display .= "</ul><p><a href='".$admin."?mode=5&action=1'>Добавить новую схему</a></p>";
			break;
		case '1':
			// Добавление новой схемы
			$display  = "<h3>Создание схемы репозитория</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='13'>\n";
			$display .= "Схема репозитория: <input type='text' name='scheme'><br>\n";
			$display .= "<input type='submit' value='Добавить'></form>\n";
			break;
		case '2':
			// Правка существующей схемы
			$req =& $db->query("SELECT * FROM scheme WHERE scheme_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($scheme, DB_FETCHMODE_ASSOC);					
				$display  = "<h3>Правка схемы репозитория</h3>";
				$display .= "<form action='./process.php' method='POST'>\n";
				$display .= "<input type='hidden' name='mode' value='14'>\n";
				$display .= "<input type='hidden' name='schemeID' value='".stripslashes($scheme["scheme_id"])."'><br>\n";
				$display .= "Схема репозитория: <input type='text' name='scheme' value='".stripslashes($scheme["scheme"])."'><br>\n";
				$display .= "<input type='submit' value='Править'></form>\n";
			} else {
				$display = "Такой схемы репозитория не существует";
			}
			break;
		case '3':
			// Удаление существующей схемы
			$req =& $db->query("SELECT * FROM scheme WHERE scheme_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($scheme, DB_FETCHMODE_ASSOC);
				$display  = "<h3>Удаление схемы репозитория</h3>";
				$display .= "Удаляемая схема: ".stripslashes($scheme["scheme"])."<br>";
				$display .= "<form action='./process.php' method='POST'>\n";
				$display .= "<input type='hidden' name='mode' value='15'>\n";
				$display .= "<input type='hidden' name='schemeID' value='".$scheme["scheme_id"]."'><br>\n";				
				$display .= "<input type='submit' value='Удалить'></form>\n";
			} else {
				$display = "Такой схемы репозитория не существует";
			}
			break;
	    }
	    break;
	case '6':
	    // Управление настройками Ant
	    switch ($act) {
		case '0':
			// Список настроек Ant
			$req =& $db->query("SELECT * FROM settings");
			$display = "<p>Имеющиеся настройки Ant</p><ul class='sectlist'>";
			if ($req->numRows()>0) {
				while ($req->fetchInto($setting, DB_FETCHMODE_ASSOC)) {
					$display .= "<li>Настройка: <em>".stripslashes($setting["opt"])."</em> Свойство: <em>".stripslashes($setting["optvalue"])."</em> [<a href='".$admin."?mode=6&action=2&uid=".$setting["opt_id"]."' class='edit'>править</a>][<a href='".$admin."?mode=6&action=3&uid=".$setting["opt_id"]."' class='delete'>удалить</a>]</li>";
				}
			}
        		$display .= "<li><a href='".$admin."?mode=6&action=1'>Добавить новую настройку</a></li><li><a href='".$admin."?mode=6&action=4'>Сменить пароль входа</a></li><li><a href='".$admin."?mode=6&action=5'>Добавить новый интерфейс</a></li><li><a href='".$admin."?mode=6&action=6'>Управление существующими интерфейсами</a></li></ul>";
			break;
		case '1':
			// Добавление новой настройки Ant
			$display  = "<h3>Создание настройки Ant</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='16'>\n";
			$display .= "Настройка (латиница, без пробелов): <input type='text' name='setoption'><br>\n";
			$display .= "Свойство (значение) настройки: <input type='text' name='setvalue'><br>\n";
			$display .= "<input type='submit' value='Добавить'></form>\n";
			break;
		case '2':
			// Правка существующей настройки Ant
			$req =& $db->query("SELECT * FROM settings WHERE opt_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($setting, DB_FETCHMODE_ASSOC);					
				$display  = "<h3>Правка настройки Ant</h3>";
				$display .= "<form action='./process.php' method='POST'>\n";
				$display .= "<input type='hidden' name='mode' value='17'>\n";
				$display .= "<input type='hidden' name='optID' value='".stripslashes($setting["opt_id"])."'><br>\n";
				$display .= "Настройка: <input type='text' name='setoption' value='".stripslashes($setting["opt"])."' readonly><br>\n";
				if ($setting["opt"]=="interface") {
					$sq =& $db->query("SELECT * FROM interfaces");
					$setvalue = "<select name='setvalue'>";
					while ($sq->fetchInto($if, DB_FETCHMODE_ASSOC)) {
						if ($if["interface"]==$setting["optvalue"]) {
							$setvalue .= "<option value='".stripslashes($if["interface"])."' selected>".stripslashes($if["interfaceinfo"])."</option>\n";
						} else {
							$setvalue .= "<option value='".stripslashes($if["interface"])."'>".stripslashes($if["interfaceinfo"])."</option>\n";
						}
					}
					$setvalue .= "</select>";
					$display .= "Свойство: ".$setvalue."<br>\n";
				} else {
					$display .= "Свойство: <input type='text' name='setvalue' value='".stripslashes($setting["optvalue"])."'><br>\n";
				}
				$display .= "<input type='submit' value='Править'></form>\n";
			} else {
				$display = "Такой настройки не существует";
			}
			break;
		case '3':
			// Удаление существующей настройки Ant
			$req =& $db->query("SELECT * FROM settings WHERE opt_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($setting, DB_FETCHMODE_ASSOC);
				$display  = "<h3>Удаление настройки Ant</h3>";
				$display .= "Удаляемая настройка <em>".stripslashes($setting["opt"])."</em> с свойством <em>".stripslashes($setting["optvalue"])."</em><br>";
				$display .= "<form action='./process.php' method='POST'>\n";
				$display .= "<input type='hidden' name='mode' value='18'>\n";
				$display .= "<input type='hidden' name='optID' value='".$setting["opt_id"]."'><br>\n";				
				$display .= "<input type='submit' value='Удалить'></form>\n";
			} else {
				$display = "Такой настройки не существует";
			}
			break;
		case '4':
			// Смена пароля входа
                        $display  = "<h3>Смена пароля</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='22'>\n";
			$display .= "Старый пароль: <input type='password' name='oldPW'><br>\n";
                        $display .= "Новый пароль: <input type='password' name='newPW1'><br>\n";
                        $display .= "Новый пароль (еще раз): <input type='password' name='newPW2'><br>\n";
			$display .= "<input type='submit' value='Сменить пароль'></form>\n";
			break;
		case '5':
			// Добавление нового интерфейса
			$display  = "<h3>Добавление нового интерфейса</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='23'>\n";
			$display .= "Интерфейс (имя файла): <input type='text' name='ifname'><br>\n";
			$display .= "Интерфейс (название): <input type='text' name='ifinfo'><br>\n";
			$display .= "<input type='submit' value='Добавить интерфейс'></form>\n";
			break;
		case '6':
			// Управление интерфейсами			
			$req =& $db->query("SELECT * FROM interfaces");
			$display  = "<h3>Управление существующими интерфейсами</h3><ul>";
			if ($req->numRows()>0) {
				while ($req->fetchInto($if, DB_FETCHMODE_ASSOC)) {
					$display .= "<li>".stripslashes($if["interfaceinfo"])." (".stripslashes($if["interface"]).") [<a href='".$admin."?mode=6&action=7&uid=".$if["if_id"]."' class='edit'>править</a>][<a href='".$admin."?mode=6&action=8&uid=".$if["if_id"]."' class='delete'>удалить</a>]</li>";
				}
			}
			$display .= "</ul>";
			break;
		case '7':
			// Правка интерфейса
			$req =& $db->query("SELECT * FROM interfaces WHERE if_id='$uid'");
			$display = "<h3>Правка интерфейса</h3>";
			if ($req->numRows()>0) {
				$req->fetchInto($if, DB_FETCHMODE_ASSOC);
				$display .= "<form action='./process.php' method='POST'>";
				$display .= "<input type='hidden' name='mode' value='24'>\n";
				$display .= "<input type='hidden' name='if' value='$uid'>\n";
				$display .= "Интерфейс (имя файла): <input type='text' name='ifname' value='".stripslashes($if["interface"])."'><br>\n";
				$display .= "Интерфейс (название): <input type='text' name='ifinfo' value='".stripslashes($if["interfaceinfo"])."'><br>\n";
				$display .= "<input type='submit' value='Отредактировать'></form>\n";
			} else {
				$display .= "<p>Такого интерфейса не существует</p>";
			}
		case '8':
			// Удаление интерфейса
			$req =& $db->query("SELECT * FROM interfaces WHERE if_id='$uid'");
			$display = "<h3>Удаление интерфейса</h3>";
			if ($req->numRows()>0) {
				$req->fetchInto($if, DB_FETCHMODE_ASSOC);
				$display .= "<form action='./process.php' method='POST'>";
				$display .= "<input type='hidden' name='mode' value='25'>\n";
				$display .= "<input type='hidden' name='if' value='$uid'>\n";
				$display .= "Интерфейс (имя файла): <input type='text' name='ifname' value='".stripslashes($if["interface"])."' readonly><br>\n";
				$display .= "Интерфейс (название): <input type='text' name='ifinfo' value='".stripslashes($if["interfaceinfo"])."' readonly><br>\n";
				$display .= "<input type='submit' value='Удалить'></form>\n";
			}
			break;
	    }
	    break;
	case '7':
	    // Управление типами репозиториев
	    switch ($act) {
		case '0':
			// Список типов репозиториев
			$req =& $db->query("SELECT * FROM rtype");
			$display = "<p>Имеющиеся типы репозиториев</p><ul class='sectlist'>";
			if ($req->numRows()>0) {
				while ($req->fetchInto($setting, DB_FETCHMODE_ASSOC)) {
					$display .= "<li>".stripslashes($setting["rtype"])." [<a href='".$admin."?mode=7&action=2&uid=".$setting["rtype_id"]."' class='edit'>править</a>][<a href='".$admin."?mode=7&action=3&uid=".$setting["rtype_id"]."' class='delete'>удалить</a>]</li>";
				}
			}
        		$display .= "</ul><p><a href='".$admin."?mode=7&action=1'>Добавить новый тип репозитория</a></p>";
			break;
		case '1':
			// Добавление нового типа репозитория
			$display  = "<h3>Создание нового типа репозитория</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='19'>\n";
			$display .= "Тип: <input type='text' name='rtype'><br>\n";			
			$display .= "<input type='submit' value='Добавить'></form>\n";
			break;
		case '2':
			// Правка существующего типа репозитория
			$req =& $db->query("SELECT * FROM rtypes WHERE rtype_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($setting, DB_FETCHMODE_ASSOC);					
				$display  = "<h3>Правка типа репозитория</h3>";
				$display .= "<form action='./process.php' method='POST'>\n";
				$display .= "<input type='hidden' name='mode' value='20'>\n";
				$display .= "<input type='hidden' name='rtypeID' value='".stripslashes($setting["rtype_id"])."'><br>\n";
				$display .= "Тип: <input type='text' name='rtype' value='".stripslashes($setting["rtype"])."'><br>\n";
				$display .= "<input type='submit' value='Править'></form>\n";
			} else {
				$display = "Такого типа репозитория не существует";
			}
			break;
		case '3':
			// Удаление существующего типа репозитория
			$req =& $db->query("SELECT * FROM rtypes WHERE rtype_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($setting, DB_FETCHMODE_ASSOC);
				$display  = "<h3>Удаление существующего типа репозитория</h3>";
				$display .= "Удаляемый тип <em>".stripslashes($setting["rtype"])."</em><br>";
				$display .= "<form action='./process.php' method='POST'>\n";
				$display .= "<input type='hidden' name='mode' value='21'>\n";
				$display .= "<input type='hidden' name='rtypeID' value='".$setting["rtype_id"]."'><br>\n";				
				$display .= "<input type='submit' value='Удалить'></form>\n";
			} else {
				$display = "Такого типа репозитория не существует";
			}
			break;
	    }
	    break;
	case '8':
	    // Управление корневыми папками репозиториев
	    switch ($act) {
		case '0':
			// Список корневых папок репозиториев
			$req =& $db->query("SELECT * FROM root");
			$display = "<h3>Имеющиеся корневые папки репозиториев</h3>";
			if ($req->numRows()>0) {
				$display .= "<ul>\n";
				while ($req->fetchInto($root, DB_FETCHMODE_ASSOC)) {
					$display .= "<li>".stripslashes($root["root_folder"])." [<a href='".$admin."?mode=8&action=2&uid=".$root["root_id"]."' class='edit'>править</a>][<a href='".$admin."?mode=8&action=3&uid=".$root["root_id"]."' class='delete'>удалить</a>]</li>";
				}
				$display .= "</ul>\n";
			} else {
				$display .= "<p>Ни одной корневой папки не найдено.</p>";
			}
			$display .= "<p><a href='".$admin."?mode=8&action=1'>Добавить новую корневую папку репозиториев</a></p>";
			break;
		case '1':
			// Добавление новой корневой папки репозиториев
			$display  = "<h3>Добавление корневой папки</h3>";
			$display .= "<form action='./process.php' method='post'>\n";
			$display .= "<input type='hidden' name='mode' value='26'>";
			$display .= "Корневая папка: <input type='text' name='rootFolder'><br>\n";
			$display .= "<input type='submit' value='Создать'>\n</form>\n";
			break;
		case '2':
			// Редактирование корневой папки репозиториев
			$display = "<h3>Редактирование корневой папки</h3>";
			$req =& $db->query("SELECT * FROM root WHERE root_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($root, DB_FETCHMODE_ASSOC);
				$display .= "<form action='./process.php' method='post'>\n";
				$display .= "<input type='hidden' name='mode' value='27'>\n";
				$display .= "<input type='hidden' name='rootID' value='$uid'>\n";
				$display .= "Корневая папка репозитория: <input type='text' name='rootFolder' value='".stripslashes($root["root_folder"])."'><br>\n";
				$display .= "<input type='submit' value='Редактировать'>\n</form>\n";
			} else {
				$display .= "<p>Такой корневой папки репозиториев не существует</p>";
			}
			break;
		case '3':
			// Удаление корневой папки репозиториев
			$display = "<h3>Удаление корневой папки</h3>";
			$req =& $db->query("SELECT * FROM root WHERE root_id='$uid'");
			if ($req->numRows()>0) {
				$req->fetchInto($root, DB_FETCHMODE_ASSOC);
				$display .= "<form action='./process.php' method='post'>\n";
				$display .= "<input type='hidden' name='mode' value='28'>\n";
				$display .= "<input type='hidden' name='rootID' value='$uid'>\n";
				$display .= "Корневая папка репозитория: <input type='text' name='rootFolder' value='".stripslashes($root["root_folder"])."' readonly><br>\n";
				$display .= "<input type='submit' value='Удалить'>\n</form>\n";
			} else {
				$display .= "<p>Такой корневой папки не существует</p>";
			}
			break;
	    }
	    break;
}

$display .= "<p><a href=\"".$admin."\">Интерфейс администратора</a></p>";

$smarty->assign('error',$error);
$smarty->assign('display',$display);
$smarty->assign('antversion',$antversion);
$smarty->assign('style',$core->getCSSList($db));
$smarty->display('admin.tpl');

?>
